--
-- GameExtensionSpecialization
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history:	

GameExtensionSpecialization = {};

function GameExtensionSpecialization.prerequisitesPresent(specializations)
    return true;
end;

function GameExtensionSpecialization:preLoad(savegame)
	self.gameExtension = {};
	
	GameExtension.callSpecFunc(self, "preLoad", {savegame});
end;

function GameExtensionSpecialization:load(savegame)
	GameExtension.callSpecFunc(self, "load", {savegame});
end;

function GameExtensionSpecialization:postLoad(savegame)
	GameExtension.callSpecFunc(self, "postLoad", {savegame});
end;

function GameExtensionSpecialization:delete()
	GameExtension.callSpecFunc(self, "delete", {});
end;

function GameExtensionSpecialization:readStream(streamId, connection)
	GameExtension.callSpecFunc(self, "readStream", {streamId, connection});
end;

function GameExtensionSpecialization:writeStream(streamId, connection)
	GameExtension.callSpecFunc(self, "writeStream", {streamId, connection});
end;

function GameExtensionSpecialization:mouseEvent(posX, posY, isDown, isUp, button)
end;

function GameExtensionSpecialization:keyEvent(unicode, sym, modifier, isDown)
end;

function GameExtensionSpecialization:update(dt)
	GameExtension.callSpecFunc(self, "update", {dt});
end;

function GameExtensionSpecialization:updateTick(dt)
	GameExtension.callSpecFunc(self, "updateTick", {dt});
end;

function GameExtensionSpecialization:draw()
	GameExtension.callSpecFunc(self, "draw", {});
end;

function GameExtensionSpecialization:onEnter(isControlling)
	GameExtension.callSpecFunc(self, "onEnter", {isControlling});
end;

function GameExtensionSpecialization:onLeave()
	GameExtension.callSpecFunc(self, "onLeave", {});
end;